-- BC3101A.ADA

--                             Grant of Unlimited Rights
--
--     Under contracts F33600-87-D-0337, F33600-84-D-0280, MDA903-79-C-0687,
--     F08630-91-C-0015, and DCA100-97-D-0025, the U.S. Government obtained 
--     unlimited rights in the software and documentation contained herein.
--     Unlimited rights are defined in DFAR 252.227-7013(a)(19).  By making 
--     this public release, the Government intends to confer upon all 
--     recipients unlimited rights  equal to those held by the Government.  
--     These rights include rights to use, duplicate, release or disclose the 
--     released technical data and computer software in whole or in part, in 
--     any manner and for any purpose whatsoever, and to have or permit others 
--     to do so.
--
--                                    DISCLAIMER
--
--     ALL MATERIALS OR INFORMATION HEREIN RELEASED, MADE AVAILABLE OR
--     DISCLOSED ARE AS IS.  THE GOVERNMENT MAKES NO EXPRESS OR IMPLIED 
--     WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING THE CONDITIONS OF THE
--     SOFTWARE, DOCUMENTATION OR OTHER INFORMATION RELEASED, MADE AVAILABLE 
--     OR DISCLOSED, OR THE OWNERSHIP, MERCHANTABILITY, OR FITNESS FOR A
--     PARTICULAR PURPOSE OF SAID MATERIAL.
--*
-- CHECK THAT THE BASE TYPE OF A GENERIC ACTUAL OBJECT PARAMETER
-- CANNOT DIFFER FROM THE BASE TYPE OF THE GENERIC FORMAL OBJECT
-- PARAMETER.

-- DAT 9/18/81
-- JRK 2/2/83

PROCEDURE BC3101A IS

     TYPE ENUM IS (E1, E2, E3, E4);

     TYPE DI IS NEW INTEGER;
     TYPE FIX IS DELTA 1.0 RANGE -1.0 .. 1.0;
     TYPE DFIX IS NEW FIX;
     TYPE DFLOAT IS NEW FLOAT;
     TYPE MFLOAT IS DIGITS FLOAT'DIGITS;
     TYPE DE IS NEW ENUM;
     TYPE DC IS NEW CHARACTER;

     TYPE REC IS 
          RECORD
               C : INTEGER;
          END RECORD;
     TYPE ARR IS ARRAY (1..1) OF INTEGER;
     TYPE AI IS ACCESS INTEGER;
     TYPE DAI IS NEW AI;

     VC : CHARACTER := 'A';
     VI : INTEGER := 6;
     VB : BOOLEAN := TRUE;
     VE : ENUM := E2;
     VDI : DI := DI(VI);
     VFIX : FIX := 0.0;
     VDFIX : DFIX := 0.0;
     VFLOAT : FLOAT := FLOAT (VDFIX);
     VDFLOAT : DFLOAT := 1.0;
     VMFLOAT : MFLOAT := 0.0;
     VDE : DE := E3;
     VDC : DC := DC(ASCII.NUL);
     VREC : REC := (C => 1);
     VARR : ARR := (1 => 1);
     VAI : AI := NEW INTEGER'(3);
     VDAI : DAI := DAI (VAI);
 
     GENERIC P : IN CHARACTER; PACKAGE GC IS END GC;
     GENERIC P : IN INTEGER; PACKAGE GI IS END GI;
     GENERIC P : IN BOOLEAN; PACKAGE GB IS END GB;
     GENERIC P : IN ENUM; PACKAGE GE IS END GE;
     GENERIC P : IN DI; PACKAGE GDI IS END GDI;
     GENERIC P : IN FIX; PACKAGE GFIX IS END GFIX;
     GENERIC P : IN DFIX; PACKAGE GDFIX IS END GDFIX;
     GENERIC P : IN FLOAT; PACKAGE GFLOAT IS END GFLOAT;
     GENERIC P : IN DFLOAT; PACKAGE GDFLOAT IS END GDFLOAT;
     GENERIC P : IN MFLOAT; PACKAGE GMFLOAT IS END GMFLOAT;
     GENERIC P : IN DE; PACKAGE GDE IS END GDE;
     GENERIC P : IN DC; PACKAGE GDC IS END GDC;
     GENERIC P : IN REC; PACKAGE GREC IS END GREC;
     GENERIC P : IN ARR; PACKAGE GARR IS END GARR;
     GENERIC P : IN AI; PACKAGE GAI IS END GAI;
     GENERIC P : IN DAI; PACKAGE GDAI IS END GDAI;
 
     GENERIC P : IN OUT CHARACTER; PACKAGE GGC IS END GGC;
     GENERIC P : IN OUT INTEGER; PACKAGE GGI IS END GGI;
     GENERIC P : IN OUT BOOLEAN; PACKAGE GGB IS END GGB;
     GENERIC P : IN OUT ENUM; PACKAGE GGE IS END GGE;
     GENERIC P : IN OUT DI; PACKAGE GGDI IS END GGDI;
     GENERIC P : IN OUT FIX; PACKAGE GGFIX IS END GGFIX;
     GENERIC P : IN OUT DFIX; PACKAGE GGDFIX IS END GGDFIX;
     GENERIC P : IN OUT FLOAT; PACKAGE GGFLOAT IS END GGFLOAT;
     GENERIC P : IN OUT DFLOAT; PACKAGE GGDFLOAT IS END GGDFLOAT;
     GENERIC P : IN OUT MFLOAT; PACKAGE GGMFLOAT IS END GGMFLOAT;
     GENERIC P : IN OUT DE; PACKAGE GGDE IS END GGDE;
     GENERIC P : IN OUT DC; PACKAGE GGDC IS END GGDC;
     GENERIC P : IN OUT REC; PACKAGE GGREC IS END GGREC;
     GENERIC P : IN OUT ARR; PACKAGE GGARR IS END GGARR;
     GENERIC P : IN OUT AI; PACKAGE GGAI IS END GGAI;
     GENERIC P : IN OUT DAI; PACKAGE GGDAI IS END GGDAI;

     PACKAGE ZA IS NEW GC (VDC);              -- ERROR: TYPE.
     PACKAGE ZB IS NEW GI (VDI);              -- ERROR: TYPE.
     PACKAGE ZC IS NEW GB (0);                -- ERROR: TYPE.
     PACKAGE ZD IS NEW GE (VDE);              -- ERROR: TYPE.
     PACKAGE ZE IS NEW GDI (VAI);             -- ERROR: TYPE.
     PACKAGE ZF IS NEW GFIX (VI);             -- ERROR: TYPE.
     PACKAGE ZG IS NEW GDFIX (VFIX);          -- ERROR: TYPE.
     PACKAGE ZH IS NEW GFLOAT (VMFLOAT);      -- ERROR: TYPE.
     PACKAGE ZI IS NEW GDFLOAT (VFLOAT);      -- ERROR: TYPE.
     PACKAGE ZJ IS NEW GMFLOAT (VDFLOAT);     -- ERROR: TYPE.
     PACKAGE ZK IS NEW GDE (VE);              -- ERROR: TYPE.
     PACKAGE ZL IS NEW GDC (VI);              -- ERROR: TYPE.
     PACKAGE ZM IS NEW GREC (VARR);           -- ERROR: TYPE.
     PACKAGE ZN IS NEW GREC (VI);             -- ERROR: TYPE.
     PACKAGE ZO IS NEW GARR (VREC);           -- ERROR: TYPE.
     PACKAGE ZP IS NEW GARR (VI);             -- ERROR: TYPE.
     PACKAGE ZQ IS NEW GAI (VDAI);            -- ERROR: TYPE.
     PACKAGE ZR IS NEW GDAI (VAI);            -- ERROR: TYPE.

     PACKAGE QA IS NEW GGC (VDC);             -- ERROR: TYPE.
     PACKAGE QB IS NEW GGI (VDI);             -- ERROR: TYPE.
     PACKAGE QC IS NEW GGB (VC);              -- ERROR: TYPE.
     PACKAGE QD IS NEW GGE (VDE);             -- ERROR: TYPE.
     PACKAGE QE IS NEW GGDI (VAI);            -- ERROR: TYPE.
     PACKAGE QF IS NEW GGFIX (VI);            -- ERROR: TYPE.
     PACKAGE QG IS NEW GGDFIX (VFIX);         -- ERROR: TYPE.
     PACKAGE QH IS NEW GGFLOAT (VMFLOAT);     -- ERROR: TYPE.
     PACKAGE QI IS NEW GGDFLOAT (VFLOAT);     -- ERROR: TYPE.
     PACKAGE QJ IS NEW GGMFLOAT (VDFLOAT);    -- ERROR: TYPE.
     PACKAGE QK IS NEW GGDE (VE);             -- ERROR: TYPE.
     PACKAGE QL IS NEW GGDC (VI);             -- ERROR: TYPE.
     PACKAGE QM IS NEW GGREC (VARR);          -- ERROR: TYPE.
     PACKAGE QN IS NEW GGREC (VI);            -- ERROR: TYPE.
     PACKAGE QO IS NEW GGARR (VREC);          -- ERROR: TYPE.
     PACKAGE QP IS NEW GGARR (VI);            -- ERROR: TYPE.
     PACKAGE QQ IS NEW GGAI (VDAI);           -- ERROR: TYPE.
     PACKAGE QR IS NEW GGDAI (VAI);           -- ERROR: TYPE.
BEGIN
     NULL;
END BC3101A;
